package com.shixing.sxedit;
import java.util.HashMap;
import java.util.Map;

abstract class SXBaseImpl implements SXBase {

    abstract long getNativeHandle();

    @Override
    public void setField(String key, String value) {
        if (getNativeHandle() != 0) {
            nSetField(getNativeHandle(), key, value);
        }
    }

    @Override
    public String getField(String key) {
        if (getNativeHandle() != 0) {
            return nGetField(getNativeHandle(), key);
        }
        return null;
    }

    @Override
    public void removeField(String key) {
        if (getNativeHandle() != 0) {
            nRemoveField(getNativeHandle(), key);
        }
    }

    @Override
    public void clearField() {
        if (getNativeHandle() != 0) {
            nClearFields(getNativeHandle());
        }
    }

    @Override
    public Map<String, String> getFields() {
        if (getNativeHandle() != 0) {
            HashMap<String, String> map = new HashMap<>();
            nGetFields(getNativeHandle(), map);
        }
        return null;
    }



    protected static native void nSetField(long nativeHandle, String key, String value);
    protected static native String nGetField(long nativeHandle, String key);
    protected static native void nRemoveField(long nativeHandle, String key);
    protected static native void nClearFields(long nativeHandle);
    protected static native void nGetFields(long nativeHandle, HashMap<String, String> map);
}
